"use strict";

var rm = require('rimraf');

var path = require('path');

var webpack = require('webpack');

var chalk = require('chalk');

var ora = require('ora');

var pkg = require('../../package.json');

var webpackConfig = require('./webpack.prod.babel');

var argv = require('../../server/argv');

var spinner = ora('building for production...'); // const Diff = require('diff');

spinner.start(); // rm(argv.releasepath ? path.resolve(argv.releasepath, pkg.name.toLocaleLowerCase()): `./${pkg.name.toLocaleLowerCase()}`, err => {
//   if (err) throw err
// })

webpack(webpackConfig, function (err, stats) {
  spinner.stop();
  if (err) throw err;
  process.stdout.write(stats.toString({
    colors: true,
    color: true,
    progress: true,
    modules: false,
    children: false,
    chunks: true,
    chunkModules: true
  }) + '\n\n');

  if (stats.hasErrors()) {
    console.log(chalk.red('  Build failed with errors.\n'));
    process.exit(1);
  }

  console.log(chalk.cyan('  Build complete.\n'));
  console.log(chalk.yellow('  Tip: built files are meant to be served over an HTTP server.\n' + '  Opening index.html over file:// won\'t work.\n'));
});